



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>String对象的match方法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">String对象的match方法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 01:29:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>RegExp对象的exec方法和String对象的match方法用法十分相似，分两篇博客讲讲其各自的用法和它们之间的异同。上一篇将<a href="http://www.cnblogs.com/youhong/p/6850603.html" rel="external nofollow noreferrer">exec方法的用法</a>，这篇讲解match方法，并比较其异同。</p>
<h3>定义与语法</h3>
<p><strong>【定义】</strong></p>
<p>match() 方法可在字符串内检索指定的值，或找到一个或多个正则表达式的匹配。</p>
<p><strong>【语法】</strong></p>
<div>
<pre class="prettyprint linenums">stringObject.match(searchvalue)<br />
stringObject.match(regexp)</pre>
</div>
<p><strong>【返回值】</strong>存放匹配结果的数组。</p>
<p>以下分3种情况讲解：</p>
<p>1）输入参数为普通字符串；</p>
<p>2）输入参数为非全局正则表达式；</p>
<p>3）输入参数为全部正则表达式。</p>
<h3>输入为普通字符串</h3>
<div>
<pre class="prettyprint linenums">var str="web2.0 .net2.0";<br />
var searchValue="e";<br />
console.log(str.match(searchValue));</pre>
</div>
<p>结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1049484/201705/1049484-20170513224406066-935433121.png" /></p>
<p>第一项：匹配到的字符串；</p>
<p>属性index：匹配字符串所在的位置；</p>
<p>属性input：输入的字符串</p>
<p>其实，在输入参数为普通字符串时，match方法与indexOf方法的作用类似，只是indexOf返回的是匹配字符串所在的位置，match返回的是匹配的字符串（可以通过index属性获得位置）。但如果只是要获得匹配的字符串就没有意义了，因为结果就是输入参数，所以一般match更多地用于在字符串中匹配模式。</p>
<h3>输入为非全局RegExp对象</h3>
<div>
<pre class="prettyprint linenums">var str="web2.0 .net2.0";<br />
var pattern=/(\w+)(\d)\.(\d)/;//没有全局标志g<br />
console.log(str.match(pattern));</pre>
</div>
<p>结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1049484/201705/1049484-20170513224407847-1484578213.png" /></p>
<p>如果看过上一篇文章<a href="http://www.cnblogs.com/youhong/p/6850603.html" rel="external nofollow noreferrer">exec方法的用法</a>，会发现结果与exec方法的结果完全相同。即：</p>
<p>第一项：web2.0，与整个模式匹配的结果，也就是与<em>/(\w+)(\d)\.(\d)/</em>匹配的结果；</p>
<p>第二项：web，与第一个匹配组匹配的结果，也就是与<em>(\w+)</em>匹配的结果；</p>
<p>第三项：2，与第二个匹配组匹配的结果，也就是与<em>(\d)</em>匹配的结果；</p>
<p>第四项：0，与第三个匹配组匹配的结果，也就是与<em>(\d)</em>（第二个(\d)）匹配的结果；</p>
<p>属性一：index:0，匹配项在字符串中的位置，也就是数组第一项的匹配字符串的位置。</p>
<p>属性二：input:"web2.0 .net2.0"，也就是输入参数str。</p>
<p>所以，当输入参数为非全局正则表达式时，match方法与exec方法结果一样，均为第一个匹配项的信息（包括捕获组匹配到的子字符串）。</p>
<h3>输入为全局RegExp对象</h3>
<div>
<pre class="prettyprint linenums">var str="web2.0 .net2.0";<br />
var pattern=/(\w+)(\d)\.(\d)/g;//有全局标志g<br />
console.log(str.match(pattern));</pre>
</div>
<p>结果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/1049484/201705/1049484-20170513224409754-1808455455.png" /></p>
<p>可以发现，结果包含两项，分别为第一个匹配项和第二个匹配项，不包括捕获组的匹配结果，也没有index和input属性。</p>
<h3>总结</h3>
<p>1）match方法为String对象的方法，输入参数可以为普通字符串或RegExp对象；</p>
<p>2）输入为普通字符串时，结果为一个数组，包含第一个匹配到的字符串；数组有两个属性，分别为匹配字符串的位置index和输入参数input；</p>
<p>3）输入为非全局RegExp对象时，结果为一个数组，包含第一个匹配项的信息，格式为[与整个模式匹配的字符串，与第一个捕获组匹配的字符串，与第二个捕获组匹配的字符串，&hellip;&hellip;]，数组有两个属性，分别为匹配得到的字符串的位置index和输入参数字符串input；</p>
<p>4）输入为全局RegExp对象时，结果为一个数组，包含所有匹配的结果，但不包含捕获组匹配的子字符串、index属性和input属性。</p>
<h3>exec()和match()异同</h3>
<p>1）exec()为RegExp对象的方法，输入参数为字符串；match()为String对象的方法，输入参数为字符串或者RegExp对象；</p>
<p>2）当RegExp对象没有全局标志g时，exec()和match()方法返回结果相同，为一个包含第一个匹配项的信息的数组，格式为[与整个模式匹配的字符串，与第一个捕获组匹配的字符串，与第二个捕获组匹配的字符串，&hellip;&hellip;]，数组有两个属性，分别为匹配得到的字符串的位置index和输入参数字符串input；</p>
<p>3）当RegExp对象有全局标志g时，exec()方法每次执行时是从上次检索的终点开始检索，返回当前检索到的一个匹配项信息；match()方法执行的结果为一个包含所有匹配项的数组，不包括捕获组匹配的子字符串、index属性和input属性。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4pv70q.html">MFC---static控件加载图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rlpr49.html">WIN8系统安装软件时提示&amp;quot&semi;扩展属性不一致&amp;quot&semi;的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qne73kq.html">centos6&period;6编译安装lnmp系列之PHP</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pozdyq.html">MSSQL 获取汉字全拼 和 汉字首字母</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq11mz2q.html">&lbrack;git&rsqb;查看某一行代码是谁写的</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1d6yz9.html">Python实现Hadoop MapReduce程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljmj1e9.html">c语言，gdb</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yjmkw8.html">静态NAT、动态NAT</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m45rm8.html">解决Maven管理的项目下&amp;quot&semi;Missing artifact xxx bundle&amp;quot&semi;问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9507wl08.html">用Unity3d做游戏（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp1vljq.html">Orm之中介模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zye3z19.html">CentOS No package nginx available&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gyy10q.html">使用PHP &plus; Apache访问有错误的php脚本时不报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4v0wm9.html">Java语法基础学习DaySeven</a>
		</li>
						<li><a href="https://www.batexi.com/a/953z4p08.html">Hive学习之路 （十）Hive的高级操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx24joz8.html">1&period;phpcms的安装和卸载文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlmgvk9.html">利率计算v2&period;0--web版--软件工程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ek1xg9.html">关于解决乱码问题的一点探索之一（涉及utf-8和GBK）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnjenmq.html">closure---     闭包与并行运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pmn26y9.html">在Linux终端管理文件你要知道的11个命令</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwlgr439.html">结合业务，精炼SQL</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjyzlxq.html">如何在CentOS 7上使用vsftpd&lpar;FTP&rpar;的配置文件介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/8koev63q.html">React 初识</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1v7l72q.html">Lambda入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlgr3l9.html">pickle 模块学习      常用方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pp4gnz9.html">iOS --高仿QQ空间页面</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kz31oq.html">STM32-增量式旋转编码器测量</a>
			</li>
						<li><a href="https://www.batexi.com/a/8koekorq.html">创建第一个flask项目</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnxgy2q.html">编程开发之--java多线程学习总结（6）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mj5xrp8.html">rbac表设计</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
